package com.gpdi.tag;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;

import com.gpdi.bean.User;

import freemarker.core.Environment;
import freemarker.template.ObjectWrapper;
import freemarker.template.SimpleNumber;
import freemarker.template.TemplateDirectiveBody;
import freemarker.template.TemplateDirectiveModel;
import freemarker.template.TemplateException;
import freemarker.template.TemplateModel;

public class HelloWorldDirective implements TemplateDirectiveModel {

	@SuppressWarnings("unchecked")
	public void execute(Environment env, Map params, TemplateModel[] loopVars,
			TemplateDirectiveBody body) throws TemplateException, IOException {
		List<User> list = getUserList(params);
		env.setVariable("list", ObjectWrapper.DEFAULT_WRAPPER.wrap(list));
		body.render(env.getOut());
	}
	
	
	@SuppressWarnings("unchecked")
	private List<User> getUserList(Map params){
		List<User> userList = new ArrayList<User>();
		 SimpleNumber vid = (SimpleNumber)params.get("id");
		 for(int i=0;i< vid.getAsNumber().intValue();i++){
			 User user = new User();
			 user.setAge((int)Math.round(Math.random()*10));
			 user.setId(i);
			 user.setName("good");
			 userList.add(user);
		 }
		 return userList;
	}
	
	
	
	
}
