package com.gpdi.util;


import java.io.IOException;
import java.io.Writer;
import java.util.Locale;
import java.util.Map;

import javax.servlet.ServletContext;

import com.gpdi.tag.HelloWorldDirective;

import freemarker.template.Configuration;
import freemarker.template.DefaultObjectWrapper;
import freemarker.template.Template;
import freemarker.template.TemplateException;

/**
 * @author ajun
 * @http://blog.csdn.net/ajun_studio  
 **/
public class FreeMarkertUtil {

	private static  Configuration config = new Configuration(); 
	
	public static void processTemplate(String templateName, Map<?,?> root, Writer out){
		try{
			Template template=config.getTemplate(templateName,"utf-8");
			template.process(root, out);   
		    out.flush();   
		} catch (IOException e) {
			e.printStackTrace();
		} catch (TemplateException e) {
			e.printStackTrace();
		}finally{
			 try {
				out.close();
				out=null;
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	/**
	 * @param servletContext javax.servlet.ServletContext
	 * @param templateDir  
	 */
	public static void initConfig(ServletContext servletContext,String templateDir){
		 	config.setLocale(Locale.CHINA);
		    config.setDefaultEncoding("utf-8");
		    config.setEncoding(Locale.CHINA, "utf-8");
		    config.setServletContextForTemplateLoading(servletContext, templateDir);
		    config.setObjectWrapper(new DefaultObjectWrapper());
		    //初始化标签
		    config.setSharedVariable("hello", new HelloWorldDirective());

	}
}

